/*
 * Copyright (c) 2002
 * Neil Spring and the University of Washington.
 * GPL
 */

#include "nscommon.h" /* boolean */
#ifndef __LCLINT__
#include <getopt.h> /* required_argument, etc. */
#else
# define no_argument		0
# define required_argument	1
# define optional_argument	2
#endif

typedef void (*commando_cb)(const char *argument, void *a);
struct commandos {
  /*@null@*/ const char *description;
  /*@null@*/ const char *long_name;
  char short_abbreviation;
  int has_arg; /* same as for getopt */
  /*@null@*/ commando_cb set_cb;
  /*@dependent @*//*@null@*/ void *value_address;
};

/* enclose this in braces, a decision made because
   of emacs indenting. */
#define END_COMMANDO NULL, NULL, '\0', 0, NULL, NULL 

void commando_int(const char *int_arg, void *pint);
void commando_strdup(const char *str_arg, void *pstr);
void commando_boolean(const char *dummy, void *pb);
void commando_unsupported(const char *dummy, void *pb);
void commando_help(const char *dummy, void *pcommandos);
void commando_usage(/*@null@*/const char *dummy, const struct commandos *c);
/* returns the argument number where processing stopped */
int commando_parse(int argc, char **argv, const struct commandos *c);
