#!/usr/bin/perl

use Gimp ":auto";
use Gimp::Fu;

my %images = ( "cpad-play", "bkg,bkgc,slash,backslash,dot,static-controls,play-control",
               "cpad-pause", "bkg,bkgc,slash,backslash,dot,static-controls,pause-control" );

sub make_controlpad {
  my($infile) = @_;
  print "hello";
  my $size = 56;
  my $color = [255,127,0];
  foreach $k ( keys %images )  {
    foreach $d ( "north", "south", "east", "west" ) {
      $images{$k . "-" . $d} = $images{$k} . ",sel-$d";
    }
  }
# Create a new image 
  foreach $k ( keys %images ) {
    $img = gimp_file_load(RUN_NONINTERACTIVE, $infile, $infile); 
    foreach $l ( $img->get_layers ) {
      $layer{gimp_layer_get_name($l)} = $l;
      gimp_layer_set_visible($l,0);
    }
    foreach $layername ( split(",", $images{$k}) ) {
      gimp_layer_set_visible($layer{$layername},1);
    }
    $layer = gimp_image_merge_visible_layers($img, CLIP_TO_BOTTOM_LAYER);
    file_xpm_save(RUN_NONINTERACTIVE, $img, $layer, "./$k.xpm", "./$k.xpm", 127);
    gimp_image_delete($img);
  }
#  I don't know how to escape returning an image.
  $img = gimp_file_load(RUN_NONINTERACTIVE, "$infile", "$infile"); 
  return $img; 
}

register "make_controlpad",
"Generate control pad xpms",
"For use with wmalbum",
"Neil Spring",
"Neil Spring (c)",
"2002-02-11",
"<Toolbox>/Xtns/Perl-Fu/ControlPad",
"*", # image types, could probably be more specific here
[
 [PF_STRING, "infile", "Input File", "./controlpad.xcf"]
],
\&make_controlpad;

exit main();
